------------------------------------------------------------------------------
--                                                                          --
--      GNATCOM - Ada 95 COM/DCOM/COM+ Development Framework and Tools      --
--                                                                          --
--                             B I N D _ C O M                              --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.2 $
--                                                                          --
--                  Copyright (C) 1999-2004 David Botton                    --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. It is distributed in the hope that it will be useful,  but WITHOUT --
-- ANY WARRANTY;  without  even the  implied warranty of MERCHANTABILITY or --
-- FITNESS FOR A PARTICULAR PURPOSE.    See the GNU General  Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- More information about GNATCOM and the most current version can          --
-- be located on the web at http://www.gnavi.org/gnatcom                    --
--                                                                          --
------------------------------------------------------------------------------

package Bind_COM is

   Verbose : Boolean := True;
   --  Tool output style

   Under_Line_Replace : Character := 'u';
   --  Character to use when replacing multiple '_'s or '_'s at start or end
   --  of an identifier

   procedure Bind (File_Name : String;
                   Base_Name : String);
   --  Create a binding to the type library contained in the file File_Name
   --  with the base package name of Base_Name

   procedure Bind (GUID      : String;
                   Major_Ver : String;
                   Minor_Ver : String;
                   Base_Name : String);
   --  Create a binding to the type library registerd with GUID and at Ver
   --  version with the base package name of Base_Name

end Bind_COM;
